/*
TDPE Shader Settings
Change stuff without much coding knowledge
If you have questions either comment on mcpedl (not those other websites)
Or my discord - https://discord.gg/j4AvK79 
                            t1ap#1613

Also I'm inactive on my twitter so don't ask questions there

How to use:
To turn off features type 0
To turn on features type 1
*/

//Features
#define WATER_TEXTURE 1 //Water Texture
#define UW_CAUSTIC 1 //Underwater effect
#define UW_DISTORTION 1 //Underwater waves
#define WATER_WAVES 1 //Water Waves
#define SPECULAR 1 //Sun Reflection
#define SUN_BEAMS 1 //Sun beams
#define UW_SUN_BEAMS 1 //Underwater water sun beams
#define PLAYER_SHADOW 1 //Player Shadow
#define PLAYER_SHADOW_3D 1 //3D Player Shadow (Laggy)
#define RAIN_EFFECT 1 //Rain effect (turning this off will also turn off RAIN_PUDDLES and RAIN_RIPPLES)
#define RAIN_PUDDLES 1 // Rain Puddle effect
#define RAIN_RIPPLES 1 // Rain Ripple effect
#define RIPPLE_MASK 1 //Ripples will not appear farther away (Recommend for lower end devices)
#define SUN_RAYS 1 // Sun rays on the sun (different from SUN_BEAMS)
#define END_GALAXY 1 // Galaxy effect on the end sky
#define END_STREAKS 1 // End streak effect
#define GLOW 1 // The light reflective shiny thingy near light sources

#define BUMP_EFFECT 0 // Normal mapping

// Older versions of features
#define OLD_WATER 0 // The old water texture from 1.1 and below
#define OLD_CLOUDS 0 // The old clouds from 1.2 and below

//Experimental Features
//These Features are turned off by default
#define CLOUD_REFLECTION 0 //Cloud reflection on water (doesn't match with the clouds)
#define PARALLAX_MAPPING 0 //3D Effect (POM) (also turning on BUMP_EFFECT is recommended)
// POM Settings 
#define PARALLAX_SIMPLE 0 // A simpler, more efficient, but less accurate implementation of parallax mapping
#define POM_INTERPOLATION 1 //Makes 3D Effect smoother (laggy)
#define INTERPOLATION_RES 4.0 //The resolution of interpolation (higher values, less interpolation)
#define POM_TWO_DEPTH 0 //POM only uses two depth values (note: this does not improve performance, this is a purely a stylistic option)
#define POM_RANGE vec2(8.0, 32.0) // Lower values are faster, but more noticable layers. vec2(Min, Max)
#define POM_TBN_SIMPLE 0 //The old way of calculating tbn (may work better on some devices but doesn't work well with rotated textures)
#define POM_MASK 1 // POM will not appear farther away (Recommend for lower end devices)
#define POM_MASK_DIST 10.0 // The distance where POM gets disabled 
//VALUES
#define CLSPEED 0.05 //Cloud Speed
#define CLHEIGHT 0.0 //Cloud height. negative values to lower clouds, positive values to raise clouds
#define BRIGHTNESS 0.0 // Negative values to decrease brightness, positive values to increase brightness
#define POM_INTENSITY 0.002 // Try not to go too high c:

//COLOURS
/*
How to change:

Each number corresponds to the intensity of each color channel.
The higher the number, the more intense the color channel.
vec3([RED], [GREEN], [BLUE])

Or sometimes it might have four numbers.
The fourth number corresponds to the alpha/opacity.
The higher the alpha, the more opaque.

vec4([RED], [GREEN], [BLUE], [ALPHA])
*/

#define LIGHT_COLOR vec3(0.7, 0.6, 0.5) // Light color emitted by every light source block
